# -*- coding: utf-8 -*-
"""
Created on Thu Dec 22 15:29:00 2016

@author: Geert
"""

import os
from PIL import Image
import numpy as np

#def create_iterator_structure(gtr_folder, fp_folder, out_folder):
def create_iterator_structure(tp_folder, fp_folder, out_folder):
    #gtr_fls = []
    #gtr_fls = [os.path.join(gtr_folder, x) for x in os.listdir(gtr_folder)]
    #tp_fls = []
    tp_fls = [os.path.join(tp_folder, x) for x in os.listdir(tp_folder)]
    #fp_fls = []
    fp_fls = [os.path.join(fp_folder, x) for x in os.listdir(fp_folder)]

    #fls = gtr_fls + fp_fls
    fls = tp_fls + fp_fls
    #labels = [1] * len(gtr_fls) + [0] * len(fp_fls)
    labels = [1] * len(tp_fls) + [0] * len(fp_fls)
    for v in xrange(9):
        try:
            os.makedirs(os.path.join(out_folder, str(v)))
        except:
            pass
    for i, (fl, lab) in enumerate(zip(fls, labels)):
        if (i - len(labels)) % 100 == 0 :
            print 'Progress: %s of %s' % (i, len(labels))
        im = np.array(Image.open(fl))
        for v in xrange(9):
            sub_im = im[:, v*65:(v+1)*65]
            pil_im = Image.fromarray(sub_im.astype("int32"), mode="I")
            in_nm = os.path.splitext(os.path.split(fl)[1])[0]
            out_nm = in_nm + "_class" + str(lab) + "_.tif"
            pil_im.save(os.path.join(out_folder, str(v), out_nm))

#create_iterator_structure(r"\\rdstorage1\diag\ProjectData\Lymphography\exp\dl\patches240_GTR",
#                          r"\\rdstorage1\diag\ProjectData\Lymphography\exp\dl\patches240_FP",
#                          r"\\rdstorage1\diag\ProjectData\Lymphography\exp\dl\iterator_structure")

#create_iterator_structure(r"D:\oscar\svn_userdata_oscar\exp\dl\patches240_GTR",
#                          r"D:\oscar\svn_userdata_oscar\exp\dl\patches240_FP",
#                          r"D:\oscar\svn_userdata_oscar\exp\dl\iterator_structure")

create_iterator_structure(r"D:\oscar\svn_userdata_oscar\exp\dl\patches240_TP_0.8509142",
                          r"D:\oscar\svn_userdata_oscar\exp\dl\patches240_FP_0.8509142",
                          r"D:\oscar\svn_userdata_oscar\exp\dl\iterator_structure_TP_FP_0.8509142")