# -*- coding: utf-8 -*-
"""
Created on Wed Aug 10 11:32:14 2016

@author: Geert
"""
import sys
sys.path.append(r"/mnt/resfilsp10/pathology/Userdata/geert/experiments/TMIDeepLearning/Python")

import multiresolutionimageinterface as mir
import os
from tmi_evaluation.metrics.dice import calculate_dice_overlap_for_wsi

obs1_pth_20x = r"/mnt/resfilsp10/pathology/Userdata/geert/experiments/TMIDeepLearning/Data/Prostatectomy/Nijmegen/20X_converted/AnnotationMasks/Natalie"
obs1_pth_10x = r"/mnt/resfilsp10/pathology/Userdata/geert/experiments/TMIDeepLearning/Data/Prostatectomy/Nijmegen/10X_converted/AnnotationMasks/Natalie"
obs2_pth_20x = r"/mnt/resfilsp10/pathology/Userdata/geert/experiments/TMIDeepLearning/Data/Prostatectomy/Nijmegen/20X_converted/AnnotationMasks/Robin"
obs2_pth_10x = r"/mnt/resfilsp10/pathology/Userdata/geert/experiments/TMIDeepLearning/Data/Prostatectomy/Nijmegen/10X_converted/AnnotationMasks/Robin"

fls_obs1_20x = os.listdir(obs1_pth_20x)
fls_obs1_10x = os.listdir(obs1_pth_10x)
fls_obs1_pths = [os.path.join(obs1_pth_20x, x) for x in fls_obs1_20x] + [os.path.join(obs1_pth_10x, x) for x in fls_obs1_10x]
fls_obs2_pths = [os.path.join(obs2_pth_20x, x) for x in fls_obs1_20x] + [os.path.join(obs2_pth_10x, x) for x in fls_obs1_10x]

reader = mir.MultiResolutionImageReader()

dices = {}
for pth_obs1, pth_obs2 in zip(fls_obs1_pths, fls_obs2_pths):
    if os.path.exists(pth_obs2):
        sld_obs1 = reader.open(pth_obs1)
        sld_obs2 = reader.open(pth_obs2)
        dices[pth_obs1] = calculate_dice_overlap_for_wsi(sld_obs1, sld_obs2, 2, 2, 1, [.5])
    else:
        print "File " + pth_obs2 + " does not exist"