# -*- coding: utf-8 -*-
"""
Created on Mon May 01 17:17:45 2017

@author: Oscar
"""
from sys import argv
from lymphography_tools import Main
#from local_tools.exceptions import AppException

if len(argv) < 2 :
  action = 'froc_after' # Default action.
else :
  action = argv[1]

if action == 'froc_before' :

### COMPUTE FROC CURVES OF SYSTEM WITHOUT FP REDUCTION:

  folders = []
  folders.append("u:/prostate/ProjectData/Lymphography/exp/dl/locations240_TP_0.8509142")
  folders.append("u:/prostate/ProjectData/Lymphography/exp/dl/locations240_FP_0.8509142")
  falseNegativesFolder = "u:/prostate/ProjectData/Lymphography/exp/dl/falseNegatives240"
  #frocFileName = "rfroc-before-FNsTic.csv"
  frocFileName = "froc_before.csv"

  mainObject = Main()
  mainObject.colNumberDict = {'likelihood': 5} # Column in which the likelihood values are to be found.
  mainObject.command = "froc"
  mainObject.computeFrocCurve(folders, falseNegativesFolder, frocFileName)


elif action == 'froc_after' :

### COMPUTE FROC CURVES OF SYSTEM WITH FP REDUCTION:

  #inputFolders = ["u:/prostate/ProjectData/Lymphography/Results/classification-with_truthIDs_epoch199"]

  #inputFolders = [r"U:\prostate\ProjectData\Lymphography\Results\classification_bestepoch\temp-with_truthIDs"]
  inputFolders = [r"/mnt/resfilsp10/prostate/ProjectData/Lymphography/Results/classification_bestepoch_1views-with_truthIDs"]

  falseNegativesFolder = "/mnt/resfilsp10/prostate/ProjectData/Lymphography/exp/dl/falseNegatives240"
  #frocFileName = "rfroc-after-FNsTic.csv"
  frocFileName = "froc_after_1views.csv"

  mainObject = Main()
  mainObject.colNumberDict = {'likelihood': 2, # Column in which the likelihood values are to be found.
                              'studyID'   : 3}
  mainObject.command = "froc"
  mainObject.computeFrocCurve(inputFolders, falseNegativesFolder, frocFileName)


elif action == 'add_truth_ids' :
  truePositivesFolder = "/mnt/resfilsp10/prostate/ProjectData/Lymphography/exp/dl/locations240_TP_0.8509142"
  resultsFolder = "/mnt/resfilsp10/prostate/ProjectData/Lymphography/Results/classification_bestepoch_1views"

  mainObject = Main()
  mainObject.addTruthNumbersToClassificationResults(truePositivesFolder, resultsFolder)
  #try :
  #  mainObject.addTruthNumbersToClassificationResults(truePositivesFolder, resultsFolder)
  #except AppException as e :
  # print 'ERROR: %s' % e


